select
    'Estoque' as Tipo,
    (case when(me.cdtipomovimentoestoque<6) then 'Entrada' else 'Sada' end) as Sentido,
    tmov.nome as tipo_movimento,
    'Estoque' as numdocumento,
    me.data as data_apropriacao,
    cc.numero ||' - '||cc.descricao as centro_custo,
    sa.descricao as safra,
    (case when (cc.cdcentrocusto is not null) then '100' else '' end) as percentual_tela,
    cg.numero ||' - '|| cg.descricao as conta_gerencial,
    'Estoque' as fornecedor,
    pr.numero as numero_produto,
    pr.nome as nome_produto,
    me.qtde as quantidade,
    cm.customedio as valor_unitario,
    cm.customedio * me.qtde as valor_total,
    (case when (nti.saidaimediata=1 or me.cdtipomovimentoestoque<6) then me.vrtotal else
        (cm.customedio * me.qtde) end) as valor_aprop_cc_nota,
    ccfin.numero ||' - '|| ccfin.descricao as centro_custo_final,
    cast((case when (rai.cdrateioitem is not null) then rai.percentual else null end) as decimal(15,2)) as percentual_rateio_final,
    cast((case
        when (ccfin.cdcentrocusto is null)
          then (case when (nti.saidaimediata=1 or me.cdtipomovimentoestoque<6) then me.vrtotal else
                    (cm.customedio * me.qtde) end)
        else (((case when (nti.saidaimediata=1 or me.cdtipomovimentoestoque<6) then me.vrtotal else
                    (cm.customedio * me.qtde) end) * rai.percentual) / 100)
        end) as decimal(15,2)) as valor_apropriado_final,
    extract (month from me.data) as mes,
    extract (year from me.data) as ano
from
    movimentoestoque me
    left join centrocusto cc on me.cdcentrocusto=cc.cdcentrocusto
    join contagerencial cg on me.cdcontagerencial=cg.cdcontagerencial
    join produto pr on me.cdproduto=pr.cdproduto
    join tipomovimentoestoque tmov on me.cdtipomovimentoestoque=tmov.cdtipomovimentoestoque
    left join notaitem nti on me.cdnotaitem=nti.cdnotaitem
    left join rateio ra on ra.cdcentrocusto = cc.cdcentrocusto and me.data between ra.dtrateio and coalesce(ra.dtfimrateio, current_date)
    left join rateioitem rai on rai.cdrateio = ra.cdrateio
    left join safra sa on sa.cdsafra = rai.cdsafra
    left join centrocusto ccfin on ccfin.cdcentrocusto = rai.cdcentrocusto
    join sp_customedio(me.data, me.cdproduto) cm on 1 = 1
where
    extract(year from me.data) = 2017
order by
    me.data, me.cdmovimentoestoque


